import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';

class Game {
  final String title;
  final String url;
  final String dev;
  final String editor;
  final String plateformes;
  final String genres;
  final String score;
  final String releaseDate;
  final String description;
  bool isSaved=false;

  Game(this.title, this.url, this.dev, this.editor, this.plateformes, this.genres, this.score, this.releaseDate,  this.description );
}

class DetailGameScreen extends StatefulWidget {
  final Game game;
  static const TextStyle boldStyle = TextStyle( fontWeight: FontWeight.bold,color: Colors.black);
  static const TextStyle classicStyle = TextStyle(color: Colors.black);
  static const TextStyle boldTitleStyle = TextStyle( fontWeight: FontWeight.bold,color: Colors.black,fontSize: 20);
  static const TextStyle classicTitleStyle = TextStyle(color: Colors.black, fontSize: 20);

  // In the constructor, require a manga
  DetailGameScreen({Key key, @required this.game}) : super(key: key);

  @override
  _DetailGameScreenState createState() => _DetailGameScreenState();
}

class _DetailGameScreenState extends State<DetailGameScreen> {
  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        title: Text("Détails de l'oeuvre"),
      ),
      body: Padding(
        padding: EdgeInsets.all(4.0),
        child: ListView(
          padding: const EdgeInsets.all(8),
          children: <Widget>[
            Container(
                height: 25,
                child:  RichText(text: TextSpan(children: <TextSpan>[
                  TextSpan(text: "Titre: ", style: DetailGameScreen.boldTitleStyle,),
                  TextSpan(text: "${widget.game.title}", style: DetailGameScreen.classicTitleStyle,),
                ],),)
            ),
            Container(
              height: 225,
              child: GridView.count(
                  childAspectRatio: 0.8,
                  crossAxisCount: 2,
                  physics: new NeverScrollableScrollPhysics(),
                  children: <Widget>[
                    Image.network(widget.game.url),
                    Align(alignment: Alignment.center, child: RichText(text: TextSpan(children: <TextSpan>[
                      TextSpan(text: "Développeurs: ", style: DetailGameScreen.boldStyle,),
                      TextSpan(text: "${widget.game.dev}\n", style: DetailGameScreen.classicStyle,),
                      TextSpan(text: "Éditeurs: ", style: DetailGameScreen.boldStyle,),
                      TextSpan(text: "${widget.game.editor}\n", style: DetailGameScreen.classicStyle,),
                      TextSpan(text: "Genres: ", style: DetailGameScreen.boldStyle,),
                      TextSpan(text: "${widget.game.genres}\n", style: DetailGameScreen.classicStyle,),
                      TextSpan(text: "Plateformes: ", style: DetailGameScreen.boldStyle,),
                      TextSpan(text: "${widget.game.plateformes}\n", style: DetailGameScreen.classicStyle,),
                      TextSpan(text: "Date de sortie: ", style: DetailGameScreen.boldStyle,),
                      TextSpan(text: "${widget.game.releaseDate}\n", style: DetailGameScreen.classicStyle,),
                      TextSpan(text: "Note communautaire: ", style: DetailGameScreen.boldStyle,),
                      TextSpan(text: "${widget.game.score}\n", style: DetailGameScreen.classicStyle,),
                    ],),))
                  ]),
            ),
            Container(
                height: 400,
                child:RichText(textAlign: TextAlign.justify,text: TextSpan(children: <TextSpan>[
                  TextSpan(text: "En bref:\n", style: DetailGameScreen.boldTitleStyle,),
                  TextSpan(text: "${widget.game.description}\n", style: DetailGameScreen.classicStyle,),
                ],),)
            )],
        ),
      ),
      floatingActionButtonLocation: FloatingActionButtonLocation.endFloat,
      floatingActionButton: new FloatingActionButton(

        onPressed:(){
          setState(() {
            if (widget.game.isSaved) {
              widget.game.isSaved=false;
            } else {
              widget.game.isSaved=true;
            }
          });
        },
        tooltip: 'Increment',
        child: new Icon( widget.game.isSaved ? Icons.favorite : Icons.favorite_border,
          color: widget.game.isSaved ? Colors.red : null,),
      ),

    );
  }
}