import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:flutter_media/DataBase.dart';

import 'Game.dart';
import 'Manga.dart';

void main() => runApp(MyApp());

/// This is the main application widget.
class MyApp extends StatelessWidget {
  static const String _title = 'Media';

  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      title: _title,
      home: MyStatefulWidget(),
    );
  }
}

/// This is the stateful widget that the main application instantiates.
class MyStatefulWidget extends StatefulWidget {
  MyStatefulWidget({Key key}) : super(key: key);

  @override
  _MyStatefulWidgetState createState() => _MyStatefulWidgetState();
}


/// This is the private State class that goes with MyStatefulWidget.
class _MyStatefulWidgetState extends State<MyStatefulWidget> {
  int _selectedIndex = 0;
  static DataBase dataBase= new DataBase();
  static const TextStyle classicStyle =
  TextStyle(fontSize: 16);
  static const TextStyle optionStyle =
  TextStyle(fontSize: 30, fontWeight: FontWeight.bold);
  static const TextStyle titleStyle =
  TextStyle(fontSize: 50, fontWeight: FontWeight.bold, color:  Colors.blue);
  static const TextStyle titleStyle2 =
  TextStyle(fontSize: 44, fontWeight: FontWeight.bold, color:  Colors.blue);

   List<Widget> _widgetOptions = <Widget>[
     ListView(
         padding: const EdgeInsets.all(2),
         physics: new NeverScrollableScrollPhysics(),
         children: <Widget>[
          Container(
            height: 70,
            child: Text('Accueil',style: titleStyle,textAlign: TextAlign.center),
          ),
           Container(
             height: 190,
             padding: const EdgeInsets.fromLTRB(6, 0, 6, 0),
             child: Text("Cette application est le fruit d'un TP réalisé dans le cadre de ma formation d'ingénieur à l'IMT.\n \nLe but était de créer une application mobile de gestion de média pour s'entrainer à utiliser différents Widgets.\n\nOn retrouve donc une liste de jeux vidéos et une de mangas, une page de favoris et une page d'information technique."
                   , style: classicStyle, textAlign: TextAlign.justify,),
           ),
           Container(
             height: 280,
             child: Align(alignment: Alignment.topCenter,child: Image.network('https://i.kym-cdn.com/photos/images/newsfeed/001/739/593/45d.jpg'),
             )),
          ]
    ),
    ListView.separated(
      physics: ScrollPhysics(),
      padding: const EdgeInsets.all(0),
      itemCount: dataBase.getGameViews().length+1,
      itemBuilder: (BuildContext context, int index) {
        if(index==0) return Container(
          height: 60,
          child: Text('Mes jeux-vidéos',style: titleStyle2,textAlign: TextAlign.center),
        );
        else return Container(
          height: 180,
          child: InkWell( onTap: () {Navigator.push(context, MaterialPageRoute(builder: (context) => DetailGameScreen(game: DataBase.games[index-1])),);
          },
            child: Center(child: dataBase.getGameViews()[index-1]),),
        );
      },
      separatorBuilder: (BuildContext context, int index) => const Divider(thickness: 5 ,color: Colors.blue, indent: 10, endIndent: 10,),
    ),
     ListView.separated(
       physics: ScrollPhysics(),
      padding: const EdgeInsets.all(8),
      itemCount: dataBase.getMangaViews().length+1,
      itemBuilder: (BuildContext context, int index) {
       if(index==0) return Container(
          height: 60,
          child: Text('Mes mangas',style: titleStyle,textAlign: TextAlign.center),
        );
      else return Container(
        height: 180,
         child: InkWell( onTap: () {Navigator.push(context, MaterialPageRoute(builder: (context) => DetailMangaScreen(manga: DataBase.mangas[index-1])),);
         },
           child: Center(child: dataBase.getMangaViews()[index-1]),),
      );
      },
      separatorBuilder: (BuildContext context, int index) => const Divider(thickness: 5 ,color: Colors.blue, indent: 10, endIndent: 10,),
    ),
    ListView.builder(
      physics: ScrollPhysics(),
      padding: const EdgeInsets.all(8),
      itemCount: dataBase.getAll().length+1,
      itemBuilder: (BuildContext context, int index) {
        if(index==0) return Container(
          height: 60,
          child: Text('Mes Favoris',style: titleStyle,textAlign: TextAlign.center),
        );
        else if(dataBase.getIsSaved(dataBase.getAll()[index-1])) return Container(
          height: 180,
          child: InkWell( onTap: ()   {
            if(dataBase.getAll()[index-1] is Manga)
             Navigator.push(context, MaterialPageRoute(builder: (context) => DetailMangaScreen(manga: dataBase.getAll()[index-1])),);
            else  Navigator.push(context, MaterialPageRoute (builder: (context) => DetailGameScreen(game: dataBase.getAll()[index-1])),);
            },
            child: Center(child: dataBase.getAllViews()[index-1]),),
        );else if(index==1 && dataBase.IsNoneSaved(dataBase.getAll())) return Container(
          height: 500,
          child: Center(child: Text("Aucun favoris" ,style: optionStyle,)),
        );
        else return Container(
          height: 0,
          child: Text("Empty"),
        );
      },
    ),
    Text(
      'Informations',
      style: optionStyle,
    ),
  ];

  void _onItemTapped(int index) {
    setState(() {
      _selectedIndex = index;
    });
  }
  
  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        title: const Text('Gestion de Médias'),
      ),
      body: Center(
        child: _widgetOptions.elementAt(_selectedIndex),
      ),
      bottomNavigationBar: BottomNavigationBar(
        type: BottomNavigationBarType.fixed,
        items: const <BottomNavigationBarItem>[
          BottomNavigationBarItem(
            icon: Icon(Icons.home),
            label: 'Accueil',
          ),
          BottomNavigationBarItem(
            icon: Icon(Icons.videogame_asset),
            label: 'Jeu Vidéo',
          ),
          BottomNavigationBarItem(
            icon: Icon(Icons.menu_book),
            label: 'Manga',
          ),
          BottomNavigationBarItem(
            icon: Icon(Icons.favorite),
            label: 'Aimés',
          ),
          BottomNavigationBarItem(
            icon: Icon(Icons.not_listed_location),
            label: 'Infos',
          ),
        ],
        currentIndex: _selectedIndex,
        selectedItemColor: Colors.blue[400],
        onTap: _onItemTapped,
      ),
    );
  }
}




